commit d2353fcd8f602a1f4fdeb31ae006e6b7bc46b349
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Fri Nov 21 14:17:39 2025 +0000

    fix TLS held-open verify to delivery

diff --git a/src/src/daemon.c b/src/src/daemon.c
index a31ef1eb5..056bf6311 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -709,11 +709,8 @@ if (pid == 0)
         signal(SIGINT, SIG_DFL);
 
         if (geteuid() != root_uid && !deliver_drop_privilege)
-          {
-          signal(SIGALRM, SIG_DFL);
 	  delivery_re_exec(CEE_EXEC_PANIC);
           /* Control does not return here. */
-          }
 
         /* No need to re-exec; SIGALRM remains set to the default handler */
 
diff --git a/src/src/deliver.c b/src/src/deliver.c
index 3dc1aef73..c978e67b5 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -9011,7 +9011,6 @@ if (cutthrough.cctx.sock >= 0 && cutthrough.callout_hold_only)
   {
   int channel_fd = cutthrough.cctx.sock;
 
-  smtp_peer_options = cutthrough.peer_options;
   continue_sequence = 0;
 
 #ifndef DISABLE_TLS
@@ -9019,9 +9018,7 @@ if (cutthrough.cctx.sock >= 0 && cutthrough.callout_hold_only)
     {
     int pfd[2], pid;
 
-    smtp_peer_options |= OPTION_TLS;
-    sending_ip_address = cutthrough.snd_ip;
-    sending_port = cutthrough.snd_port;
+    cutthrough.peer_options |= OPTION_TLS;
 
     where = US"socketpair";
     if (socketpair(AF_UNIX, SOCK_STREAM, 0, pfd) != 0)
@@ -9034,7 +9031,7 @@ if (cutthrough.cctx.sock >= 0 && cutthrough.callout_hold_only)
 
     if (pid == 0)	/* child: will fork again to totally disconnect */
       {
-      smtp_proxy_tls(cutthrough.cctx.tls_ctx, big_buffer, big_buffer_size,
+      smtp_proxy_tls(&cutthrough.cctx, big_buffer, big_buffer_size,
 		      pfd, 5*60, cutthrough.host.name);
       /* does not return */
       }
@@ -9046,8 +9043,7 @@ if (cutthrough.cctx.sock >= 0 && cutthrough.callout_hold_only)
     }
 #endif
 
-  transport_do_pass_socket(cutthrough.transport, cutthrough.host.name,
-    cutthrough.host.address, cutthrough.host.port, message_id, channel_fd);
+  transport_do_pass_socket(message_id, channel_fd);
   }
 else
   {
diff --git a/src/src/exim.c b/src/src/exim.c
index c23eb868c..a50303049 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -405,13 +405,13 @@ Returns:   nothing
 */
 
 static void
-milliwait(struct itimerval *itval)
+milliwait(struct itimerval * itval)
 {
 sigset_t sigmask;
 sigset_t old_sigmask;
 int save_errno = errno;
 
-if (itval->it_value.tv_usec < 50 && itval->it_value.tv_sec == 0)
+if (itval->it_value.tv_usec < 50 && itval->it_value.tv_sec <= 0)
   return;
 (void)sigemptyset(&sigmask);                           /* Empty mask */
 (void)sigaddset(&sigmask, SIGALRM);                    /* Add SIGALRM */
@@ -3000,7 +3000,16 @@ on the second character (the one after '-'), to save some effort. */
 
       if (!continue_proxy_cipher)
 	if (getsockname(0, (struct sockaddr *)(&tmp_sock), &size) == 0)
-	  sending_ip_address = host_ntoa(-1, &tmp_sock, NULL, &sending_port);
+	  switch (tmp_sock.v0.sa_family)
+	    {
+	    case AF_INET:
+	    case AF_INET6:
+	      sending_ip_address =
+		    host_ntoa(-1, &tmp_sock, NULL, &sending_port);
+	      break;
+	    default:
+	      exim_fail("non-INET socket on stdin for -MC option");
+	    }
 	else
 	  exim_fail("getsockname() failed after -MC option: %s",
 	    strerror(errno));
diff --git a/src/src/functions.h b/src/src/functions.h
index 73371cc7b..937259334 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -551,7 +551,7 @@ extern void    smtp_log_no_mail(void);
 extern void    smtp_message_code(uschar **, int *, uschar **, uschar **, BOOL);
 extern void    smtp_notquit_exit(const uschar *, uschar *, const uschar *, ...);
 extern void    smtp_port_for_connect(host_item *, int);
-extern void    smtp_proxy_tls(void *, uschar *, size_t, int *, int, const uschar *) NORETURN;
+extern void    smtp_proxy_tls(client_conn_ctx *, uschar *, size_t, int *, int, const uschar *) NORETURN;
 extern BOOL    smtp_read_response(void *, uschar *, int, int, int);
 rmark	       smtp_reset(rmark);
 extern void    smtp_respond(uschar *, int, BOOL, uschar *);
@@ -662,8 +662,7 @@ extern uschar *tod_stamp(int);
 extern BOOL    transport_check_waiting(const uschar *, const uschar *, int, uschar *,
                  oicf, void*);
 extern uschar *transport_current_name(void);
-extern void    transport_do_pass_socket(const uschar *, const uschar *,
-		 const uschar *, int, uschar *, int);
+extern void    transport_do_pass_socket(uschar *, int);
 extern void    transport_init(void);
 extern const uschar *transport_rcpt_address(address_item *, BOOL);
 extern BOOL    transport_set_up_command(const uschar ***, const uschar *,
diff --git a/src/src/globals.c b/src/src/globals.c
index 36f364996..38fdbc7a3 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -665,14 +665,8 @@ open_db *continue_wait_db      = NULL;
 #endif
 
 uschar *csa_status             = NULL;
-cut_t   cutthrough = {
-  .callout_hold_only =	FALSE,				/* verify-only: normal delivery */
-  .delivery =		FALSE,				/* when to attempt */
-  .tpt_sender =		FALSE,				/* use tpt's sender */
-  .defer_pass =		FALSE,				/* on defer: spool locally */
-  .is_tls =		FALSE,				/* not a TLS conn yet */
+cut_t   cutthrough = {	/* All remaining items 0/FALSE/NULL */
   .cctx =		{.sock = -1},			/* open connection */
-  .nrcpt =		0,				/* number of addresses */
 };
 
 int	daemon_notifier_fd     = -1;
diff --git a/src/src/globals.h b/src/src/globals.h
index 9f4d04a2d..1c133f5ea 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -474,11 +474,14 @@ extern open_db *continue_wait_db;      /* Hintsdb for wait-transport */
 extern uschar *csa_status;             /* Client SMTP Authorization result */
 
 typedef struct {
-  unsigned     callout_hold_only:1;    /* Conn is only for verify callout */
-  unsigned     delivery:1;             /* When to attempt */
-  unsigned     tpt_sender:1;           /* Use tpt-defined sender */
-  unsigned     defer_pass:1;           /* Pass 4xx to caller rather than spooling */
-  unsigned     is_tls:1;	       /* Conn has TLS active */
+  BOOL		callout_hold_only:1;    /* Conn is only for verify callout */
+  BOOL		delivery:1;             /* When to attempt */
+  BOOL		tpt_sender:1;           /* Use tpt-defined sender */
+  BOOL		defer_pass:1;           /* Pass 4xx to caller rather than spooling */
+  BOOL		is_tls:1;	       /* Conn has TLS active */
+  BOOL		is_dane:1;
+  uschar *	sni;
+  uschar *	cipher;
   client_conn_ctx cctx;                /* Open connection */
   int          nrcpt;                  /* Count of addresses */
   uschar *     transport;	       /* Name of transport */
diff --git a/src/src/transport.c b/src/src/transport.c
index a59a5ae3d..5d3b8a732 100644
--- a/src/src/transport.c
+++ b/src/src/transport.c
@@ -2025,16 +2025,17 @@ retfalse:
 *    Deliver waiting message down same socket    *
 *************************************************/
 
-/* Just the regain-root-privilege exec portion */
+/* Just the regain-root-privilege exec portion.
+The sole caller is delivery_re_exec(). */
+
 void
-transport_do_pass_socket(const uschar * transport_name, const uschar * hostname,
-  const uschar * hostaddress, int hostport, uschar * id, int socket_fd)
+transport_do_pass_socket(uschar * id, int socket_fd)
 {
 int i = 14;
 const uschar **argv;
 
 #ifndef DISABLE_TLS
-if (smtp_peer_options & OPTION_TLS) i += 6;
+if (cutthrough.peer_options & OPTION_TLS) i += 6;
 #endif
 #ifndef DISABLE_ESMTP_LIMITS
 if (continue_limit_mail || continue_limit_rcpt || continue_limit_rcptdom)
@@ -2051,27 +2052,27 @@ but we have a number of extras that may be added. */
 argv = CUSS child_exec_exim(CEE_RETURN_ARGV, TRUE, &i, FALSE, 0);
 
 if (f.smtp_authenticated)			argv[i++] = US"-MCA";
-if (smtp_peer_options & OPTION_CHUNKING)	argv[i++] = US"-MCK";
-if (smtp_peer_options & OPTION_DSN)		argv[i++] = US"-MCD";
-if (smtp_peer_options & OPTION_PIPE)		argv[i++] = US"-MCP";
-if (smtp_peer_options & OPTION_SIZE)		argv[i++] = US"-MCS";
+if (cutthrough.peer_options & OPTION_CHUNKING)	argv[i++] = US"-MCK";
+if (cutthrough.peer_options & OPTION_DSN)	argv[i++] = US"-MCD";
+if (cutthrough.peer_options & OPTION_PIPE)	argv[i++] = US"-MCP";
+if (cutthrough.peer_options & OPTION_SIZE)	argv[i++] = US"-MCS";
 #ifndef DISABLE_TLS
-if (smtp_peer_options & OPTION_TLS)
-  if (tls_out.active.sock >= 0 || continue_proxy_cipher)
+if (cutthrough.peer_options & OPTION_TLS)
+  if (cutthrough.is_tls)
     {
     argv[i++] = US"-MCt";
-    argv[i++] = sending_ip_address;
-    argv[i++] = string_sprintf("%d", sending_port);
-    argv[i++] = tls_out.active.sock >= 0 ? tls_out.cipher : continue_proxy_cipher;
+    argv[i++] = cutthrough.snd_ip;
+    argv[i++] = string_sprintf("%d", cutthrough.snd_port);
+    argv[i++] = cutthrough.cipher;
 
-    if (tls_out.sni)
+    if (cutthrough.sni)
       {
       argv[i++] =
 #ifdef SUPPORT_DANE
-        tls_out.dane_verified ? US"-MCr" :
+        cutthrough.is_dane ? US"-MCr" :
 #endif
         US"-MCs";
-      argv[i++] = tls_out.sni;
+      argv[i++] = cutthrough.sni;
       }
     }
   else
@@ -2107,11 +2108,11 @@ if (proxy_session)
 #endif
 
 argv[i++] = US"-MC";
-argv[i++] = US transport_name;
-argv[i++] = US hostname;
-argv[i++] = US hostaddress;
-argv[i++] = string_sprintf("%d", hostport);
-argv[i++] = string_sprintf("%d", continue_sequence + 1);
+argv[i++] = US cutthrough.transport;
+argv[i++] = US cutthrough.host.name;
+argv[i++] = US cutthrough.host.address;
+argv[i++] = string_sprintf("%d", cutthrough.host.port);
+argv[i++] = string_sprintf("%d", continue_sequence + 1); /*XXX always 0+1 */
 argv[i++] = id;
 argv[i++] = NULL;
 
diff --git a/src/src/transports/smtp.c b/src/src/transports/smtp.c
index 36b6370fd..7160f0616 100644
--- a/src/src/transports/smtp.c
+++ b/src/src/transports/smtp.c
@@ -3881,7 +3881,7 @@ Do blocking full-size writes, and reads under a timeout.  Once both input
 channels are closed, exit the process.
 
 Arguments:
-  ct_ctx	tls context
+  ctx		client context
   buf		space to use for buffering
   bufsiz	size of buffer
   pfd		pipe filedescriptor array; [0] is comms to proxied process
@@ -3892,11 +3892,12 @@ Does not return.
 */
 
 void
-smtp_proxy_tls(void * ct_ctx, uschar * buf, size_t bsize, int * pfd,
+smtp_proxy_tls(client_conn_ctx * ctx, uschar * buf, size_t bsize, int * pfd,
   int timeout, const uschar * host)
 {
-struct pollfd p[2] = {{.fd = tls_out.active.sock, .events = POLLIN},
+struct pollfd p[2] = {{.fd = ctx->sock, .events = POLLIN},
 		      {.fd = pfd[0], .events = POLLIN}};
+void * tls_ctx = ctx->tls_ctx;
 int rc, i;
 BOOL send_tls_shutdown = TRUE;
 
@@ -3930,7 +3931,7 @@ do
 
     if (p[0].revents & POLLERR || p[1].revents & POLLERR)
       {
-      DEBUG(D_transport) debug_printf("select: exceptional cond on %s fd\n",
+      DEBUG(D_transport) debug_printf("poll: err cond on %s fd\n",
 	p[0].revents & POLLERR ? "tls" : "proxy");
       if (!(p[0].revents & POLLIN || p[1].events & POLLIN))
 	goto done;
@@ -3941,7 +3942,7 @@ do
 
   /* handle inbound data */
   if (p[0].revents & POLLIN)
-    if ((rc = tls_read(ct_ctx, buf, bsize)) <= 0)	/* Expect -1 for EOF; */
+    if ((rc = tls_read(tls_ctx, buf, bsize)) <= 0)	/* Expect -1 for EOF; */
       {				    /* that reaps the TLS Close Notify record */
       p[0].fd = -1;
       shutdown(pfd[0], SHUT_WR);
@@ -3965,19 +3966,19 @@ do
 # ifdef EXIM_TCP_CORK  /* Use _CORK to get TLS Close Notify in FIN segment */
       (void) setsockopt(tls_out.active.sock, IPPROTO_TCP, EXIM_TCP_CORK, US &on, sizeof(on));
 # endif
-      tls_shutdown_wr(ct_ctx);
+      tls_shutdown_wr(tls_ctx);
       send_tls_shutdown = FALSE;
       shutdown(tls_out.active.sock, SHUT_WR);
       }
     else
       for (int nbytes = 0; rc - nbytes > 0; nbytes += i)
-	if ((i = tls_write(ct_ctx, buf + nbytes, rc - nbytes, FALSE)) < 0)
+	if ((i = tls_write(tls_ctx, buf + nbytes, rc - nbytes, FALSE)) < 0)
 	  goto done;
   }
 while (p[0].fd >= 0 || p[1].fd >= 0);
 
 done:
-  if (send_tls_shutdown) tls_close(ct_ctx, TLS_SHUTDOWN_NOWAIT);
+  if (send_tls_shutdown) tls_close(tls_ctx, TLS_SHUTDOWN_NOWAIT);
   testharness_pause_ms(100);	/* let logging complete */
   exim_exit(EXIT_SUCCESS);
 }
@@ -5108,7 +5109,7 @@ if (sx->completed_addr && sx->ok && sx->send_quit)
 	      if (pid == 0)	/* child; fork again to disconnect totally */
 		{
 		/* does not return */
-		smtp_proxy_tls(sx->cctx.tls_ctx, sx->buffer, sizeof(sx->buffer),
+		smtp_proxy_tls(&sx->cctx, sx->buffer, sizeof(sx->buffer),
 			      pfd, ob->command_timeout, host->name);
 		}
 
diff --git a/src/src/verify.c b/src/src/verify.c
index 1fee97150..84134e49c 100644
--- a/src/src/verify.c
+++ b/src/src/verify.c
@@ -1157,7 +1157,12 @@ no_conn:
 	? "cutthrough delivery" : "potential further verifies and delivery");
 
       cutthrough.callout_hold_only = !cutthrough.delivery;
-      cutthrough.is_tls =	tls_out.active.sock >= 0;
+      if ((cutthrough.is_tls =	tls_out.active.sock >= 0))
+	{
+	cutthrough.is_dane =	tls_out.sni && tls_out.dane_verified;
+	cutthrough.sni =	tls_out.sni;
+	cutthrough.cipher =	tls_out.cipher;
+	}
       /* We assume no buffer in use in the outblock */
       cutthrough.cctx =		sx->cctx;
       cutthrough.nrcpt =	1;

